﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;

namespace VSMCommandPatternDemo
{
    public class MessageViewModel : INotifyPropertyChanged
    {
        private string _myMessage;

        public string MyMessage
        {
            get { return _myMessage; }
            set
            {
                if (_myMessage != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("MyMessage"));
                }

                _myMessage = value;
            }
        }

        public ICommand MessageBoxCommand { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        public MessageViewModel()
        {
            MessageBoxCommand = new Commands.MessageBoxCommand(this);
        }
    }
}
